// PrestoService.cs
//
// PRESTO Starter Kit for Microsoft .NET 3.0
// 2007 Microsoft France
// Published under the CECILL-B Free Software license agreement.
// (http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.txt)
// 
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// WHETHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED 
// WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE. 
// THE ENTIRE RISK OF USE OR RESULTS IN CONNECTION WITH THE USE OF THIS CODE 
// AND INFORMATION REMAINS WITH THE USER. 
//

using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel.Channels;
using System.ServiceModel;
using System.Runtime.Serialization;
using System.IO;
using System.Management.Instrumentation;

using dgme.finances.gouv.fr.presto;

[assembly: ContractNamespaceAttribute("http://dgme.finances.gouv.fr/presto", ClrNamespace = "dgme.finances.gouv.fr.presto")]
namespace Microsoft.Presto.StarterKit
{
    [ServiceBehavior(IncludeExceptionDetailInFaults = true)]
    [TraceBehavior()]
    public class PrestoService : AbstractPrestoService, IPresto, IPresto2
    {                    
        public void submitOneWay(submit1WayMessage messageIn)
        {
            OutputTrace.Log("Processing PrestoService(IPresto)::submitOneWay");

            if ((messageIn != null) && (messageIn.submitOneWay != null))
                SaveMessage(messageIn.submitOneWay.testDocIn);
        }

        public submitResponseMessage submit(submitRequestMessage messageIn)
        {
            try
            {
                OutputTrace.Log("Processing PrestoService(IPresto2)::submit");

                submitResponseMessage responseMsg = new submitResponseMessage();
                responseMsg.submitResponse = new submitResponse();
                responseMsg.submitResponse.testDocOut = messageIn.submit.testDocIn;

                if ((messageIn != null) && (messageIn.submit != null))
                    SaveMessage(messageIn.submit.testDocIn);

                return responseMsg;
            }
            catch (Exception ex)
            {
                System.Diagnostics.Trace.Write(ex.Message);
                if (ex.InnerException != null)
                    System.Diagnostics.Trace.Write(ex.InnerException.Message);
                
                return null;
            }
        }
    }
}